/*
 * Copyright (c) 2003, Morpho Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the Morpho Project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package jp.morpho.webapp.servlet.jsp.tagext;

import java.util.HashMap;
import java.util.Map;

import jp.morpho.webapp.Plugin;
import jp.morpho.webapp.PluginContext;
import jp.morpho.webapp.PluginException;
import jp.morpho.webapp.PluginKeys;
import jp.morpho.webapp.servlet.jsp.tagext.html.HtmlEncoder;
import jp.morpho.webapp.servlet.jsp.tagext.html.HtmlEncoderImpl;

/**
 * <P>
 * このクラスは、TagTemplate オブジェクトを保持し、JavaServer Pages においてカスタムタグが実行された際に、そのタグへ属性を提供します。
 * </P>
 * @author user
 */
public class TagManager
	implements Plugin
{

	/** 要求を受け取るサーブレットのパスのマップ */
	private Map tagTemplateMap = new HashMap();

	/** HTMLのためのエンコーディングオブジェクト */
	private HtmlEncoder htmlEncoder = null;

	/** null のタグ名 */
	private static final String NULL_NAME = "";

	/** null のタグタイプ */
	private static final String NULL_TAGTYPE = "";

	/**
	 * <P>
	 * TagManager を構築します。
	 * </P>
	 */
	public TagManager()
	{
		super();
		this.setHtmlEncoder(new HtmlEncoderImpl());
	}

	/**
	 * <P>
	 * TagTemplate オブジェクトをマップオブジェクトに関連付けるためのキーを作成します。
	 * </P>
	 * <P>
	 * これは次のようなキーを作成します。
	 * <CODE>
	 * TagTemplate[tagType=<I>タグのタイプ</I>,name=<I>タグ名</I>]
	 * </CODE>
	 * </P>
	 * @param tagType タグのタイプ
	 * @param name タグ名
	 * @return TagTemplate オブジェクトのキー
	 */
	public synchronized String generateTagTemplateKey(String tagType, String name)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("TagTemplate[");
		buf.append("tagType=").append((tagType != null) ? tagType : NULL_TAGTYPE);
		buf.append(",");
		buf.append("name=").append((name != null) ? name : NULL_NAME);
		buf.append("]");

		return buf.toString();
	}

	/**
	 * <P>
	 * このコンテキストに TagTemplate を追加します。
	 * </P>
	 * @param fe コンテキストに追加される TagTemplate
	 * @exception IllegalArgumentException 同じタグタイプで同じ名前の TagTemplate があった場合
	 */
	public synchronized void addTagTemplate(TagTemplate fe)
	{
		String key = generateTagTemplateKey(fe.getTagType(), fe.getName());
		if (tagTemplateMap.containsKey(key))
		{
			throw new IllegalArgumentException("TagTemplate already exists: " + key);
		}
		tagTemplateMap.put(key, fe);
	}

	/**
	 * <P>
	 * このコンテキストから指定された名前の TagTemplate を返します。
	 * コンテキストがこの名前の TagTemplate を保持していない場合は null を返します。
	 * </P>
	 * @param tagType TagTemplate のタグタイプ
	 * @param name TagTemplate の名前
	 * @return 指定された名前の TagTemplate 。この名前に対する TagTemplate がコンテキストにない場合は null
	 */
	public synchronized TagTemplate getTagTemplate(String tagType, String name)
	{
		String key = generateTagTemplateKey(tagType, name);
		return (TagTemplate)tagTemplateMap.get(key);
	}

	/**
	 * <P>
	 * TagManager プラグインを識別するためのキーを返します。
	 * </P>
	 * @return TagManager プラグインを識別するためのキー
	 * @see jp.morpho.webapp.Plugin#getPluginKey()
	 */
	public final String getPluginKey()
	{
		return PluginKeys.tagManager;
	}

	/**
	 * <P>
	 * プラグインコンテキストを設定します。
	 * フレームワークでは、プラグインインスタンスが追加された時にこのメソッドを呼び出します。
	 * </P>
	 * @param fc このインスタンスを追加した FrameworkContext オブジェクト
	 * @exception PluginException このメソッドによってスローされ、何らかのエラーが原因で障害が発生したことを示す
	 */
	public void setPluginContext(PluginContext fc)
		throws PluginException
	{
	}

	/**
	 * <P>
	 * pluginActivate メソッドは、インスタンスが活性化状態になるときに呼び出されます。
	 * インスタンスを初期化します。
	 * </P>
	 * @exception PluginException このメソッドによってスローされ、何らかのエラーが原因で障害が発生したことを示す
	 */
	public void pluginActivate()
		throws PluginException
	{
	}

	/**
	 * <P>
	 * フレームワークでは、プラグインオブジェクトの有効期間を終わらせる前にこのメソッドを呼び出します。
	 * すべてのリソースを解放します。
	 * </P>
	 * @exception PluginException このメソッドによってスローされ、何らかのエラーが原因で障害が発生したことを示す
	 */
	public void pluginRemove()
		throws PluginException
	{
	}

	/**
	 * Returns the htmlEncoder.
	 * @return HtmlEncoder
	 */
	public HtmlEncoder getHtmlEncoder()
	{
		return htmlEncoder;
	}

	/**
	 * Sets the htmlEncoder.
	 * @param htmlEncoder The htmlEncoder to set
	 */
	public void setHtmlEncoder(HtmlEncoder htmlEncoder)
	{
		this.htmlEncoder = htmlEncoder;
	}

}
